import sys
from TEMPy.StructureBlurrer import StructureBlurrer
from TEMPy.StructureParser import PDBParser
from TEMPy.MapParser import MapParser
from TEMPy.RigidBodyParser import RBParser
from TEMPy.ShowPlot import Plot
from TEMPy.ScoringFunctions import ScoringFunctions


#map file
m = sys.argv[1]
#prot file
p = sys.argv[2]
#resolution
r = float(sys.argv[3])
# rigid body file indicating segments to be scored
rb_file = sys.argv[4]


# the sigma factor determines the width of the Gaussian distribution used to describe each atom
sim_sigma_coeff = 0.187

# make class instances for density simulation (blurring), scoring and plot scores
blurrer = StructureBlurrer()
scorer = ScoringFunctions()
Plot=Plot()

# read map file
emmap=MapParser.readMRC(m)
# read PDB file
structure_instance=PDBParser.read_PDB_file('pdbfile',p,hetatm=False,water=False)
# generate atom density and blur to required resolution
sim_map = blurrer.gaussian_blur(structure_instance, r,densMap=emmap,sigma_coeff=sim_sigma_coeff,normalise=True)
SCCC_list_structure_instance=[]
# read rigid body file and generate structure instances for each segment
listRB=RBParser.read_FlexEM_RIBFIND_files(rb_file,structure_instance)
# score each rigid body segment
for RB in listRB:
  # sccc score
  score_SCCC=scorer.SCCC(emmap,6.6,sim_sigma_coeff,structure_instance,RB)
  SCCC_list_structure_instance.append(score_SCCC)
  print score_SCCC
# generate chimera attribute file for coloring segments based on sccc score 
listRB=RBParser.RBfileToRBlist(rb_file)
Plot.PrintOutChimeraAttributeFileSCCC_Score(p,SCCC_list_structure_instance,listRB)

